# -*- coding: utf-8 -*-
"""
PCA
"""
import numpy as np
import matplotlib.pyplot as plt
from sklearn import  datasets,decomposition
iris=datasets.load_iris()# 使用 scikit-learn 自带的 iris 数据集
X,y = iris.data,iris.target
pca=decomposition.PCA(n_components=2) # 使用默认的 n_components
pca.fit(X)
print('explained variance ratio : %s'% str(pca.explained_variance_ratio_))
X_r=pca.transform(X) # 原始数据集转换到二维
    ###### 绘制二维数据 ########
fig=plt.figure()
ax=fig.add_subplot(1,1,1)
colors=((1,0,0),(0,1,0),(0,0,1),(0.5,0.5,0),(0,0.5,0.5),(0.5,0,0.5),
        (0.4,0.6,0),(0.6,0.4,0),(0,0.6,0.4),(0.5,0.3,0.2),) # 颜色集合，不同标记的样本染不同的颜色
for label ,color in zip( np.unique(y),colors):
    position=y==label
    ax.scatter(X_r[position,0],X_r[position,1],label="target= %d"%label,color=color)

ax.set_xlabel("X[0]")
ax.set_ylabel("Y[0]")
ax.legend(loc="best")
ax.set_title("PCA")
plt.show()
#plt.imsave('./new_img_rgb.png',img_rgb) 